Bad Hair Day(POJ 3250) 单调栈

来源:互联网 发布:淘宝 没销量 换宝贝 编辑:程序博客网 时间:2024/05/19 14:19

来自《挑战程序设计竞赛》

单调栈的应用

这道题可以说是单调站的入门题。。。

单调栈,顾名思义,栈中的元素是单调递增或者单调递减的。

1.题目原文

http://poj.org/problem?id=3250
Bad Hair Day
Time Limit: 2000MS Memory Limit: 65536KTotal Submissions: 17768 Accepted: 5998

Description

Some of Farmer John's N cows (1 ≤ N ≤ 80,000) are having a bad hair day! Since each cow is self-conscious about her messy hairstyle, FJ wants to count the number of other cows that can see the top of other cows' heads.

Each cow i has a specified height hi (1 ≤ h≤ 1,000,000,000) and is standing in a line of cows all facing east (to the right in our diagrams). Therefore, cow i can see the tops of the heads of cows in front of her (namely cows i+1, i+2, and so on), for as long as these cows are strictly shorter than cow i.

Consider this example:

        ==       ==   -   =         Cows facing right -->=   =   == - = = == = = = = =1 2 3 4 5 6 

Cow#1 can see the hairstyle of cows #2, 3, 4
Cow#2 can see no cow's hairstyle
Cow#3 can see the hairstyle of cow #4
Cow#4 can see no cow's hairstyle
Cow#5 can see the hairstyle of cow 6
Cow#6 can see no cows at all!

Let ci denote the number of cows whose hairstyle is visible from cow i; please compute the sum of c1 through cN.For this example, the desired is answer 3 + 0 + 1 + 0 + 1 + 0 = 5.

Input

Line 1: The number of cows, N
Lines 2..N+1: Line i+1 contains a single integer that is the height of cow i.

Output

Line 1: A single integer that is the sum of c1 through cN.

Sample Input

610374122

Sample Output

5

Source

USACO 2006 November Silver

2.解题思路

题目要求每头牛能看到的牛的数目之和,换个角度思考,题目即是求每头牛可以被其他牛看到的数目之和。
可以声明一个栈,每加入一个牛时,就把栈中的比该元素小的牛删除,这样栈中的牛都能看到这头牛,栈中元素的个数就是能看到这头牛的个数。每次都把这头牛加入栈中,维护单调栈,可以得知栈中元素总是单调递减的。(栈底的元素最大)时间复杂度为O(n)。

3.AC代码

#include<algorithm>#include<cctype>#include<cmath>#include<cstdio>#include<cstdlib>#include<cstring>#include<iomanip>#include<iostream>#include<map>#include<queue>#include<string>#include<set>#include<vector>#include<cmath>#include<bitset>#include<stack>#include<sstream>#include<deque>using namespace std;#define INF 0x7fffffffconst int maxn=1005;typedef long long ll;int main(){    int n,h,t;    ll sum=0;    scanf("%d",&n);    stack<int> s;    scanf("%d",&h);    s.push(h);    for(int i=1;i<n;i++){        scanf("%d",&t);        while(!s.empty()&&t>=s.top()){            s.pop();        }        sum+=s.size();        s.push(t);    }    printf("%lld\n",sum);    return 0;}



0 0